/* $Id: thread-util.h,v 1.4 2005/01/23 21:34:59 slay Exp $ */

#ifndef __THREAD_H__
#define __THREAD_H__

#include <libnet.h>

#ifdef HAVE_PTHREAD_H
#include <pthread.h>
#endif

#define THREAD_TIMEOUT -2

struct condsem {
	pthread_mutex_t mutex;
	pthread_cond_t condvar;
	u_int16_t value;
};

typedef struct {
       pthread_t id;
       u_int8_t  stop;
} THREAD;

int8_t  thread_create(pthread_t *, void *, void *);
int8_t  thread_destroy_cancel(pthread_t);
int8_t  thread_destroy(THREAD *);
void    thread_error(int8_t *, int8_t);
void    thread_libnet_error(int8_t *, libnet_t *);
int8_t  thread_create_condsem(struct condsem *);
void    thread_delete_condsem(struct condsem *);
int8_t  thread_wait_cond(struct condsem *);
int8_t  thread_wait_cond_timed(struct condsem *, struct timeval *);
int8_t  thread_signal_cond(struct condsem *);
int8_t  thread_send_broadcast(struct condsem *, int8_t);
void   *thread_calloc_r(size_t);
void    thread_free_r(void *);

/* Extern functions...*/
extern void write_log( u_int16_t mode, int8_t *msg, ... );

#endif
/* vim:set tabstop=4:set expandtab:set shiftwidth=4:set textwidth=78: */
